/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package mipsopcodes;

/**
 *
 * @author Nshidbaby
 */
public class Itype {
    private String rs;
    private String rt;
    private String imm;
    private String iopcode;

    private short newrs;
    private short newrt;
    private short allonechk;

    private int   newimm;
    


    private void setValues(String iopcode, String bistring){
        this.iopcode = iopcode;
        this.rs = bistring.substring(0,5);
        this.rt = bistring.substring(5,10);
        this.imm = bistring.substring(10,26);

        int i;
        newrs = 0;
        newrt = 0;
        newimm = 0;
        char high = '1';
        for (i=0; i<5; i++){
            if(rs.charAt(i) ==  high){
               newrs += Math.pow(2,4-i);
            }
            if(rt.charAt(i) == high){
                newrt += Math.pow(2,4-i);
            }
        }
        //Must check for sign extended
        if (imm.charAt(0) == high){
            for(i=1; i<16; i++){
                if(imm.charAt(i) == '0'){
                    newimm += Math.pow(2, 15-(i-1));
                    break;
                }
            }
            for (i=i+1; i<16; i++){
                if(imm.charAt(i) == high){
                    newimm += Math.pow(2, 15-i);
                }
            }
            allonechk = 0;
            for (i=1; i<16; i++){
                if (imm.charAt(i) == '0'){
                    allonechk = 1;
                    break;
                }
            }
            if (allonechk == 0){
                newimm = 1;
            }
            newimm = -1*newimm;
        } else {
            for (i=0; i<16; i++){
                if(imm.charAt(i) ==  high){
                   newimm += Math.pow(2,15-i);
                }
            }
        }
    }
    public String getImm(){
        return imm;
    }
    public void getInstruction(){
        if (iopcode.equals("001000")){
            System.out.println("addi $" + newrt + ", $" + newrs + ", " + newimm);
        } else if (iopcode.equals("001001")){
            System.out.println("addiu $" + newrt + ", $" + newrs + ", " + newimm);
        } else if (iopcode.equals("001100")){
            System.out.println("andi $" + newrt + ", $" + newrs + ", " + newimm);
        } else if (iopcode.equals("000100")){
            System.out.println("beq $" + newrs + ", $" + newrt + ", (label)" + newimm);
        } else if (iopcode.equals("000001") && rt.equals("00001")){
            System.out.println("bgez $" + newrs + ", (label)" + newimm);
        } else if (iopcode.equals("000111") && rt.equals("00000")){
            System.out.println("bgtz $" + newrs + ", (label)" + newimm);
        } else if (iopcode.equals("000110") && rt.equals("00000")){
            System.out.println("blez $" + newrs + ", (label)" + newimm);
        } else if (iopcode.equals("000001") && rt.equals("00000")){
            System.out.println("bltz $" + newrs + ", (label)" + newimm);
        } else if (iopcode.equals("000101")){
            System.out.println("bne $" + newrs + ", $" + newrt + ", (label)" + newimm);
        } else if (iopcode.equals("100000")){
            System.out.println("lb $" + newrt + ", " + newimm + "($" + newrs +")");
        } else if (iopcode.equals("100100")){
            System.out.println("lbu $" + newrt + ", " + newimm + "($" + newrs +")");
        } else if (iopcode.equals("100001")){
            System.out.println("lh $" + newrt + ", " + newimm + "($" + newrs +")");
        } else if (iopcode.equals("100101")){
            System.out.println("lhu $" + newrt + ", " + newimm + "($" + newrs +")");
        } else if (iopcode.equals("001111")){
            System.out.println("lui $" + newrt + ", " + newimm);
        } else if (iopcode.equals("100011")){
            System.out.println("lw $" + newrt + ", " + newimm + "($" + newrs +")");
        } else if (iopcode.equals("110001")){
            System.out.println("lwc1 $" + newrt + ", " + newimm + "($" + newrs +")");
        } else if (iopcode.equals("001101")){
            System.out.println("ori $" + newrt + ", $" + newrs + ", " + newimm);
        } else if (iopcode.equals("101000")){
            System.out.println("sb $" + newrt + ", " + newimm + "($" + newrs +")");
        } else if (iopcode.equals("001010")){
            System.out.println("slti $" + newrt + ", $" + newrs + ", " + newimm);
        } else if (iopcode.equals("001011")){
            System.out.println("sltiu $" + newrt + ", $" + newrs + ", " + newimm);
        } else if (iopcode.equals("101001")){
            System.out.println("sh $" + newrt + ", " + newimm + "($" + newrs +")");
        } else if (iopcode.equals("101011")){
            System.out.println("sw $" + newrt + ", " + newimm + "($" + newrs +")");
        } else if (iopcode.equals("111001")){
            System.out.println("swc1 $" + newrt + ", " + newimm + "($" + newrs +")");
        } else if (iopcode.equals("001110")){
            System.out.println("xori $" + newrt + ", $" + newrs + ", " + newimm);
        } else {
            System.out.println("Instruction Not Found!!!");
        }
    }
    public Itype(String opcode, String bistring){
        setValues(opcode, bistring);
    }
}